
package com.huimv.farm.damsubsidy.config;

import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;
import org.springframework.web.servlet.config.annotation.InterceptorRegistry;
import org.springframework.web.servlet.config.annotation.WebMvcConfigurer;


@Configuration
public class InterceptorConfig implements WebMvcConfigurer {
    @Bean
    public JWTInterceptor jwtInterceptor(){
        return new JWTInterceptor();
    }

    @Override
    public void addInterceptors(InterceptorRegistry registry) {
        registry.addInterceptor(jwtInterceptor()).
                excludePathPatterns("/admSubsidy/sys-user/*","/admSubsidy/bill-subsidy/print"
                        ,"/admSubsidy/bill-subsidy/printPay","/admSubsidy/bill-subsidy/printAmount",
                        "/admSubsidy/bill-subsidy/printWaitPay","/admSubsidy/bill-subsidy/QRCode");
    }
}

